[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[Xen-devel] [OSSTEST PATCH v2 5/5] Debian: Work around Debian stretch bug with disk device names



The Debian stretch i386 installer does not have Xen PV-on-HVM drivers.
When we run the HVM guest installer, it therefore sees /dev/sda (the
emulated IDE).  But the booted system *has* the drivers and sees
/dev/xvda.

The Debian installer is supposed to put UUID= in the bootloader config
and so on in the installed system.  However, this does not work due to
a bug (Debian #852323).  Work around it.

Signed-off-by: Ian Jackson <ian.jackson@xxxxxxxxxxxxx>
---
 Osstest/Debian.pm | 19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

diff --git a/Osstest/Debian.pm b/Osstest/Debian.pm
index 41aa28b0..600f18b1 100644
--- a/Osstest/Debian.pm
+++ b/Osstest/Debian.pm
@@ -893,6 +893,23 @@ END
 
     preseed_ssh($ho, $sfx);
 
+    if ($suite =~ m/stretch/) {
+       # Debian #852323.  On stretch i386 HVM the disk device is sda
+       # in the installer environment and xvda in the installed
+       # system.  This isn't supposed to matter because the installed
+       # system is supposed to have root=UUID=... in its grub.cfg,
+       # but due to a bug the relevant udev rules are not rerun
+       # between the fs block dev getting its uuid and running
+       # grub install.  Rerun the udev rules here.  In a moment
+       # we will retrigger the update-grub...
+       preseed_hook_command($ho, 'late_command', '', <<'END');
+#!/bin/sh
+set -ex
+
+udevadm trigger
+END
+    }
+
     preseed_hook_command($ho, 'late_command', '', <<'END');
 #!/bin/sh
 set -ex
@@ -902,6 +919,8 @@ if [ -f /target$grub ] ; then
     in-target sed -i \
         's/^\(GRUB_CMDLINE_LINUX_DEFAULT=".*\)\bquiet\b\(.*"\)$/\1\2/g' \
         $grub
+    # needed for the removal of "quiet" to take effect but
+    # also to pick up the #852323 workaround (see above).
     in-target update-grub
 fi
 END
-- 
2.11.0


_______________________________________________
Xen-devel mailing list
Xen-devel@xxxxxxxxxxxxxxxxxxxx
https://lists.xenproject.org/mailman/listinfo/xen-devel

 


Rackspace

Lists.xenproject.org is hosted with RackSpace, monitoring our
servers 24x7x365 and backed by RackSpace's Fanatical Support®.